#!/bin/sh

# Generate system call probe description macros from syscall metadata dump file.
# lttng-syscalls-generate-headers.sh

INPUT=$1

sed 's/^\[.*\] //g' ${INPUT} > ${INPUT}.tmp

# move all system calls uing pointers to a separate file.
grep "\\*\|cap_user_header_t" ${INPUT}.tmp > pointers-${INPUT}

#move the rest to a "easy" file.
grep -v "\\*\|cap_user_header_t" ${INPUT}.tmp > integers-${INPUT}

echo "/* THIS FILE IS AUTO-GENERATED. DO NOT EDIT */" > pointers-${INPUT}.h
echo "#include <linux/syscalls.h>" > pointers-${INPUT}.h
echo "" >> pointers-${INPUT}.h

sed 's/^syscall \([^ ]*\) nr \([^ ]*\) nbargs \([^ ]*\) types: (\([^)]*\)) args: (\([^)]*\))/BUILD_PROBE\3(\1, \2, PARAMS(\4), PARAMS(\5))/g' \
	pointers-${INPUT} >> pointers-${INPUT}.h

echo "/* THIS FILE IS AUTO-GENERATED. DO NOT EDIT */" > integers-${INPUT}.h
echo "#include <linux/syscalls.h>" > integers-${INPUT}.h
echo "" >> integers-${INPUT}.h

sed 's/^syscall \([^ ]*\) nr \([^ ]*\) nbargs \([^ ]*\) types: (\([^)]*\)) args: (\([^)]*\))/BUILD_PROBE\3(\1, \2, PARAMS(\4), PARAMS(\5))/g' \
	integers-${INPUT} >> integers-${INPUT}.h
